--- title: "Account validation with Plaid" description: "Use Plaid for account validation of ACH Direct Debit payments." url: "https://docs.adyen.com/payment-methods/ach-direct-debit/verification-with-plaid" source_url: "https://docs.adyen.com/payment-methods/ach-direct-debit/verification-with-plaid.md" canonical: "https://docs.adyen.com/payment-methods/ach-direct-debit/verification-with-plaid" last_modified: "2026-05-26T13:48:55+02:00" language: "en" --- # Account validation with Plaid Use Plaid for account validation of ACH Direct Debit payments. [View source](/payment-methods/ach-direct-debit/verification-with-plaid.md) When accepting ACH Direct Debit payments, [Nacha](https://www.nacha.org) requires you to validate that the shopper's bank account details are correct, if it is a consumer account. To make this validation easier for you, we have partnered with **Plaid**. Plaid collects the shopper's permission to connect their account to Plaid, and verifies the account details directly with the shopper's bank. Benefits: * Smooth shopper experience. Shoppers link their account using Plaid Link. Shoppers do not need to search for their account number and routing number. * You send us the shopper's Plaid processor token instead of having to deal with sensitive account details. * Plaid collects the shopper's permission to store their details and check their account balance. * Real-time balance check. This reduces the chance that transactions are reversed because of insufficient funds. It can also save shoppers having to pay overdraft fees or non-sufficient funds fees. If you do not want to validate the account with Plaid, you need to collect the shopper's bank account number, bank routing number, and account holder name, and pass these details in the payment request. ## Requirements | Requirement | Description | | -------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | **Integration type** | Make sure that you have built an [Advanced flow](/online-payments/build-your-integration/advanced-flow/?platform=Web) Web Drop-in, Web Components, or API-only integration. | | **Limitations** | Depending on their bank, shoppers may need to re-authenticate with Plaid after a number of months. The token itself doesn't change, but you need to re-initialize it. You cannot use account validation with Plaid if your integration uses the `/sessions` endpoint. | | **Setup steps** | Before you begin:1) Reach out to your Adyen contact to configure your Adyen account for collaboration with Plaid. 2) [Add ACH Direct Debit in your Customer Area](/payment-methods/add-payment-methods). 3) [Create an account with Plaid](https://dashboard.plaid.com/signup), and complete an [application profile](https://dashboard.plaid.com/team/application) and a [company profile](https://dashboard.plaid.com/team/company). Plaid will give you a `client_id` and a `secret` to make API calls to Plaid. | ## How it works 1. The shopper selects ACH Direct Debit on your payment form. 2. You check if the shopper has already connected their account with Plaid. 3. If the shopper's account isn't connected to Plaid yet: * You direct the shopper to Plaid Link. * You make a series of API requests to Plaid to get the shopper's Plaid processor token. 4. You make a payment with the shopper's Plaid processor token and optionally include parameters to check the customer's account balance. We use the shopper's Plaid processor token to validate their account details with Plaid. The following diagram illustrates this flow. ![](/user/pages/docs/08.payment-methods/05.ach-direct-debit/verification-with-plaid/ach-with-plaid-flow.svg?decoding=auto\&fetchpriority=auto) For more insights, see Plaid's documentation on the [Plaid - Adyen partnership](https://plaid.com/docs/auth/partnerships/). ## Check the shopper's processor token It is possible that with a previous payment to you, the shopper connected their account to Plaid and you saved their Plaid processor token. If you do not have the shopper's Plaid processor token, you need to direct the shopper to the Plaid Link app and get their token. Proceed as follows: 1. In your POST [/paymentMethods](https://docs.adyen.com/api-explorer/Checkout/latest/post/paymentMethods) request, make sure to use: * `currency`: set to **USD**. * `countryCode`: set to **US**. 2. When the shopper selects **ACH Direct Debit**, on your payment form collect: * The account owner's name. * The shopper's billing address (optional). * Any other details to be able to look up this shopper in your database. 3. Based on the provided details, look up the shopper in your database and check if you have their Plaid processor token. 4. If you have the shopper's Plaid processor token, proceed to [make a payment](#make-a-payment). 5. If you do not have the shopper's Plaid processor token, get it from Plaid: 1. Make a series of requests to Plaid from your backend: * A POST [`/link/token/create` ](https://plaid.com/docs/api/link/#linktokencreate)request to initialize the Plaid Link app and get a `public_token`. * A POST [`/item/public_token/exchange` ](https://plaid.com/docs/api/items/#itempublic_tokenexchange)request with the `public_token` to get an `access_token`. * A POST [`/processor/token/create` ](https://plaid.com/docs/api/processors/#processortokencreate)request with the `access_token` to get the shopper's `processor_token`. For the details, see [Plaid's instructions for Adyen integrations](https://plaid.com/docs/auth/partnerships/). 2. Save the shopper's processor token, and proceed to [make a payment](#make-a-payment). ## Make a payment The **ACH Direct Debit** payment request must include the shopper's Plaid processor token. Optionally you can add parameters to check if the account balance meets specific conditions before trying an authorization. You can also [tokenize](/online-payments/tokenization) the transaction for future recurring payments. Proceed as follows: 1. From your server, make a POST [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) request. Specify the following parameters: | Parameter | Required | Description | | ------------------------- | ------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------- | | `paymentMethod.type` | ![-white\_check\_mark-](/user/data/smileys/emoji/white_check_mark.png "-white_check_mark-") | Set to **ach**. | | `paymentMethod.ownerName` | ![-white\_check\_mark-](/user/data/smileys/emoji/white_check_mark.png "-white_check_mark-") | The account holder name that you collected on your payment form when the shopper selected ACH Direct Debit. | | `billingAddress` | | The account owner's address information. | | `additionalData` | | The shopper's Plaid processor token and any balance check parameters you want to use. | These are the Plaid parameters you can use in `additionalData`: | Parameter | Description | | ------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `plaid.processorToken` | The shopper's Plaid processor token that you received from Plaid and stored in your database. *Required for validation with Plaid.* | | `plaid.balanceCheck` | A string value set to **true** if you want us to check the account balance. | | `plaid.minimumAmount` | A string value indicating the minimum amount available on the account, in [minor units](/development-resources/currency-codes). Use only with `plaid.balanceCheck` set to **true**. For example, if the balance must be USDĀ 10 or more, specify **1000**. You can also use this in combination with `plaid.balanceMultiplier`. | | `plaid.balanceMultiplier` | A string value indicating the condition that the account balance must at least be X times the payment amount. If `plaid.minimumAmount` is specified, indicates the condition that the account balance must at least be X times the specified minimum amount. For example, if the balance must be at least 2.5 times USDĀ 10, set `plaid.balanceMultiplier` to **2.5** and set `plaid.minimumAmount` to **1000**. | **ACH Direct Debit payment with Plaid validation** ```json curl https://checkout-test.adyen.com/v72/payments \ -H 'x-api-key: ADYEN_API_KEY' \ -H 'content-type: application/json' \ -X POST \ -d '{ "merchantAccount":"YOUR_MERCHANT_ACCOUNT", "amount":{ "currency":"USD", "value":"12000" }, "paymentMethod":{ "type":"ach", "ownerName":"ACCOUNT_HOLDER_NAME" }, "reference":"YOUR_ORDER_NUMBER", "additionalData":{ "plaid.processorToken":"processor-development-ef6a7fe3-5984-4437-994b-41e565197426", "plaid.balanceCheck":"true", "plaid.balanceMinimumAmount":"10000", "plaid.balanceMultiplier":"2.5" }, "billingAddress":{ "houseNumberOrName":"50", "street":"Test Street", "city":"Amsterdam", "stateOrProvince":"NY", "postalCode":"12010", "country":"US" } }' ``` 2. Check the [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) response. The `additionalData` object contains the validation result: | Parameter | Description | | -------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `achdirectdebit.dateOfSignature` | The date that the shopper gave permission to collect direct debit payments from their account. | | `achdirectdebit.mandateId` | The identification of the shopper's permission to collect direct debit payments from their account. This ID is the same as the PSP reference of the payment. | | `achdirectdebit.sequenceType` | Indicates if the direct debit payments are recurring. Possible values: **OneOff**, **First**. | | `availableBalanceValue` | The account balance. Only included if the request has `plaid.balanceCheck` **true**. Note that the balance is *not* in minor units. | | `bankSummary` | The last four digits of the shopper's bank account. | | `bankVerificationResult` | The result of the account validation and balance checks: **Passed**. If the validation fails, you receive an [error](#plaid-errors) message. | | `bankVerificationResultRaw` | The details of the account validation result. For example: *Passed: Available Balance greater than threshold* if you asked for a balance check with conditions. *Passed: Routing number and Account number successfully retrieved* if you didn't ask for a balance check. | | `plaidProcessorToken` | The shopper's Plaid processor token passed in the request. | Other parameters in the response include: | Parameter | Description | | -------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `pspReference` | Our unique reference for the payment. | | `resultCode` | **Authorised**. This means that the payment has been successfully received by Adyen. However, it may take up to 5 business days to know whether the payment was authorized by the bank. | **Response with Plaid validation details** ```json { "additionalData": { "achdirectdebit.dateOfSignature": "2023-02-22", "achdirectdebit.mandateId": "P27P5Q9LM7MKDM92", "achdirectdebit.sequenceType": "OneOff", "availableBalanceValue": "300.0", "bankSummary": "0000", "bankVerificationResult": "Passed", "bankVerificationResultRaw": "Passed: Available Balance greater than threshold", "plaidProcessorToken": "processor-development-ef6a7fe3-5984-4437-994b-41e565197426", }, "pspReference": "P27P5Q9LM7MKDM92", "resultCode": "Authorised", "amount": { "currency": "USD", "value": 12000 }, "merchantReference": "b3d74f31-67a2-4aa6-9b1c-d6980499985f", "paymentMethod": { "type": "ach" } } ``` If you do not get an **Authorised** response, refer to [Handle Plaid validation errors](#plaid-errors). The payment is sent to the bank. If the payment is successful, it will appear in the [Settlement details report](/reporting/settlement-detail-report). If it fails, you will receive a [CHARGEBACK](#chargebacks) webhook. ### Handle Plaid validation errors If the Plaid validation failed, you get an error response like the following example. **Example Plaid validation error** ```json { "status": 422, "errorCode": "32_003", "message": "Please have customer reauthenticate with Plaid", "errorType": "validation", "pspReference": "QTSXQ59LM7MKDM92" } ``` Make sure that your integration can handle the following validation error responses: | Error | Description | | -------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | 51\_001 - Plaid service is currently unavailable | Try again later. | | 51\_002 - Unknown error for Plaid | Try again later. | | 51\_003 - Let the customer re-authenticate with Plaid | The shopper's Plaid processor token needs to be re-initialized. Direct the shopper to the [Plaid Link update mode](https://plaid.com/docs/link/update-mode/). The token itself doesn't change. | | 51\_004 - No valid checking or savings accounts for which account and routing numbers could be retrieved | Ask the shopper to try another account or bank. | | 51\_005 - Plaid internal error | Plaid was unable to process the request. Possible causes:- An issue in the response from the bank. - An issue with the shopper's consent to sharing data with Plaid. Some banks require the shopper to confirm they gave their consent to Plaid. Ask the shopper to try again later. | | 51\_006 - Plaid rate limit exceeded. Please try again later | Too many requests were made in a short period of time. Possible causes:- You used Plaid Sandbox credentials in the Plaid Developer or Production environment. - The shopper entered their credentials incorrectly too many times. Ask the shopper to try again in one or two days. | ## Present the payment result Use the [resultCode](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments#responses-200-resultCode) that you received in the [/payments](https://docs.adyen.com/api-explorer/Checkout/latest/post/payments) response to present the payment result to your shopper. The `resultCode` values you can receive for ACH Direct Debit are: | resultCode | Description | Action to take | | -------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------- | | **Authorised** | The payment has been successfully received by Adyen. It may take up to 5 business days to know whether the payment was authorized by the bank. If the payment is successful, it will appear in the [Settlement Detail Report](/reporting/settlement-detail-report). If it fails, you will receive a [CHARGEBACK](#chargebacks) webhook. | Inform the shopper that the payment was successful. | | **Refused** | The payment was refused. | Ask the shopper to try the payment again using a different payment method. | ## Test and go live To test the connection with Plaid, use the [Plaid sandbox](https://plaid.com/docs/). Optionally use the [Plaid GitHub repo](https://github.com/plaid/sandbox-custom-users) to test specific scenarios. Before you go live, create a Plaid developer account and run tests in the [Plaid Developer environment](https://plaid.com/docs/). ## See also * [Account validation with giact](/payment-methods/ach-direct-debit/verification-with-giact) * [Tokenization](/online-payments/tokenization) * [Webhooks](/development-resources/webhooks) * [ACH Direct Debit chargebacks](/risk-management/chargeback-guidelines/ach-chargebacks)